const assert = require('assert');
const { Before, Given, When, Then } = require('@cucumber/cucumber');

const { fixtures } = require('../../test/fixtures/server');

const mockValidConfig = fixtures.get('valid-config');
const mockInvalidConfig = fixtures.get('invalid-config');

const xMessageResponse = function(xMessages) {
  const message = fixtures.get('message-vehicle-status');
  let response = [];
  for (let i=0; i<xMessages; i++) {
    response.push({
      topic: "broadcast",
      message: JSON.stringify(message)
    });
  }
  return response;
};

When('the queue contains {int} messages', function(xMessages) {
  const response = xMessageResponse(xMessages);
  this.mockAxios.onGet(
    `${mockValidConfig.api}/receive`, 
  ).reply(200, response);
});

When('the poll method is called', async function() {
  this.messages = await this.adapter.poll()
  .then((response) => {
    return response.data;
  });
});

Then('a successful response is returned with {int} messages', function(xMessages) {
  assert.equal(this.messages.length, xMessages);
});